#include "Feedable.h"

namespace {
    std::string CLOSE_BRACKET(" )");
}

bool Feedable::openRannuText() {
    using namespace std;

    bool b = true;
    file.open( pathName.c_str() );
    if( file.fail() ) {
        error = "e12: file.open( " + pathName + CLOSE_BRACKET;
        createErrorText(error);
        b = false;
    }

    return b;
}

bool FileOutputNewLine::ending(bool csv) {
    using namespace std;

    if(csv) {
        for(;;) {
            file << separator;
            itemCount += 1;
            if(itemCount >= FIELD_COUNT) {
                file << endl;
                break;
            }

        }

    } else {
        file << endl;
    }

    file.close();
    return true;
}

bool FileOutputNewLineCount::ending(bool csv) {
    using namespace std;

    if(csv) {
        for(;;) {
            if(itemCount < FIELD_COUNT) {
                file << separator;
                itemCount += 1;
            } else {
                if(lineCount < limit) {
                    file << endl;
                }

                break;
            }

        }

    }

    file.close();
    return true;
}

bool StandardOutputNewLine::ending(bool csv) {
    using namespace std;

    if(csv) {
        for(;;) {
            cout << separator;
            itemCount += 1;
            if(itemCount >= FIELD_COUNT) {
                cout << endl;
                break;
            }

        }

    } else {
        cout << endl;
    }

    return true;
}

bool StandardOutputNewLineCount::ending(bool csv) {
    using namespace std;

    if(csv) {
        for(;;) {
            if(itemCount < FIELD_COUNT) {
                cout << separator;
                itemCount += 1;
            } else {
                if(lineCount < limit) {
                    cout << endl;
                }

                break;
            }

        }

    }

    return true;
}

FileOutputNewLine::FileOutputNewLine(std::string & p) {
    pathName = p;
}

FileOutputNewLineCount::FileOutputNewLineCount(std::string & p, int l) {
    pathName = p;
    limit = l;
}

long FileOutputNewLine::writing(std::string & item) {
    using namespace std;

    file << item << separator;
    size += FIELD_SIZE;
    itemCount += 1;
    if(itemCount >= FIELD_COUNT) {
        file << endl;
        size += NEW_LINE_SIZE;
        itemCount = 0;
    }

    return size;
}

long FileOutputNewLineCount::writing(std::string & item) {
    using namespace std;

    file << item << separator;
    size += FIELD_SIZE;
    itemCount += 1;
    if(itemCount >= FIELD_COUNT) {
        file << endl;
        lineCount += 1;
        if(lineCount >= limit) {
            itemCount = FIELD_COUNT;
            size = LARGE_SIZE;
        } else {
            itemCount = 0;
            size += NEW_LINE_SIZE;
        }

    }

    return size;
}

long StandardOutputNewLine::writing(std::string & item) {
    using namespace std;

    cout << item << separator;
    size += FIELD_SIZE;
    itemCount += 1;
    if(itemCount >= FIELD_COUNT) {
        cout << endl;
        size += NEW_LINE_SIZE;
        itemCount = 0;
    }

    return size;
}

long StandardOutputNewLineCount::writing(std::string & item) {
    using namespace std;

    cout << item << separator;
    size += FIELD_SIZE;
    itemCount += 1;
    if(itemCount >= FIELD_COUNT) {
        cout << endl;
        lineCount += 1;
        if(lineCount >= limit) {
            itemCount = FIELD_COUNT;
            size = LARGE_SIZE;
        } else {
            itemCount = 0;
            size += NEW_LINE_SIZE;
        }

    }

    return size;
}

void createErrorText(std::string & messages) {
    using namespace std;

    ofstream file(ERROR_TEXT);
    file << messages << endl;
}
